<template>
  <view class="page-raw-receipt">
    <!-- 头部 -->
    <view class="header" :style="{ backgroundColor: `rgba(23, 83, 234, ${scrollTop / 100})` }">
      <view class="left">
        <u-icon class="icon" name="arrow-left" @click="uni.navigateBack()" />
      </view>
      <view class="title">{{ $t('message.CommissionGoOut') }}</view>
      <view class="right"></view>
    </view>
    <view class="content">
      <!-- 单号 -->
      <view class="single">
        <view class="single-left">
          <view>{{ $t('message.CommissionedSingleNumber') }}</view>
          <u-search :placeholder="$t('message.InventoryPleaseScan')" v-model.trim="form.documentNo" @search="query" :show-action="false"></u-search>
        </view>
        <view class="single-right">
          <u-button type="primary" @click="query">{{ $t('message.Query') }}</u-button>
        </view>
      </view>
      <!-- 物料 -->
      <view class="material">
        <view class="material-left">
          <view>{{ $t('message.CommissionedMaterielNo') }}</view>
          <jPicker sureColor="#ff0000" style="width: 260rpx" @bindpicker="materialChoice" showKey="value" valKey="value" :val="every.materialCode" class="search" :options="materialList" />
        </view>
      </view>
      <view class="material">
        <view class="material-right">
          <view class="material-right-title">{{ $t('message.CommissionedMaterielDesc') }}</view>
          <view class="material-right-code" style="overflow: hidden">{{ every.materialDesc }}</view>
        </view>
      </view>
      <!-- 需求数量 -->
      <view class="number">
        <view class="number-left">
          <view class="number-left-title">{{ $t('message.CommissionedDemandData') }}</view>
          <u-input v-model="every.orderAmount" placeholder=" " :type="type" :border="border" class="input" disabled  style="padding:'0';"/>
        </view>
        <view class="number-right">
          <view class="number-right-title">{{ $t('message.Cumulative') }}</view>
          <u-input placeholder=" " v-model="every.outAmount" :type="type" :border="border" class="input" style="padding:'0';" disabled />
        </view>
      </view>
      <!-- 库位 -->
      <view class="library">
        <view class="library-left">
          <view>{{ $t('message.CommissionedLocation') }}</view>
          <jPicker sureColor="#ff0000" style="width: 230rpx" @bindpicker="LocationChoice" showKey="value" valKey="value" :val="wlCode.value" class="search" :options="Loc" />
        </view>
        <view class="library-right">
          <view class="library-right-title">{{ $t('message.CommissionedThisNumber') }}</view>
          <u-input :placeholder="$t('message.po_PleaseInput')" v-model="nowAmount" type="number" :border="border" class="input" />
        </view>
      </view>
      <!-- 添加 -->
      <view class="add">
        <u-button type="primary" @click="Add">{{ $t('message.product_add') }}</u-button>
      </view>
      <!-- 表格 -->
      <wyb-table class="table" ref="table" width="100%" show-left-and-right-border :headers="detailHeader" :contents="list" :show-vert-border="false" @onCellClick="deleteItem($event)"></wyb-table>
    </view>
    <!-- 底部按钮 -->
    <view class="bottom-bar">
      <u-row class="button-bar">
        <u-col :span="3">
          <u-button type="primary" @click="bill">{{ $t('message.CommissionedDetails') }}</u-button>
        </u-col>
        <u-col :span="3">
          <u-button type="primary" @click="close">{{ $t('message.Closed') }}</u-button>
        </u-col>
        <u-col :span="3">
          <u-button type="primary" @click="onSubmit">{{ $t('message.product_Upload') }}</u-button>
        </u-col>
        <u-col :span="3">
          <u-button type="error" @click="uni.navigateBack()">{{ $t('message.po_Return') }}</u-button>
        </u-col>
      </u-row>
    </view>
  </view>
</template>
<script lang="ts">
import { Component, Ref } from 'vue-property-decorator';
import { BasePage } from '@/components/base/page';
import jPicker from '@/components/J-Picker/jPicker.vue';
import { session } from '@/store/modules/session';
import { detailHeader } from './config';
import model from './model';
@Component({
  components: {
    jPicker,
  },
})
export default class dnReceiptDom extends BasePage {
  model = model;
  detailHeader = detailHeader
  form: any = {
    documentNo: '',
  };
  material: any = {};
  materialList: any = [];
  list: any = [];
  every: any = '';
  value = '';
  type = 'text';
  border = true;
  nowAmount: any = '';
  //库位
  Loc: any = [];
  //所选择的库位
  wlCode: any = '';
  materialIndex:any = null
  //页面初始化
  async onReady() {
    //页面初始化 获取可选库位
    let means: any = JSON.parse(localStorage.getItem('__GWMS_APP_STATE_DATA__') as any);
    let sendSpot = JSON.parse(localStorage.getItem('sendSpot') as any);
    let content = {
      loginName: means.session.user.loginName,
      sendSpot: sendSpot,
      factoryCode: means.session.user.factoryCode,
      workArea: session.workareaCode,
    };
    await this.model.queryCodeAndWorkAreaCode(content);
    this.model.LocList.forEach((item: any) => {
      let pickerName: any = {};
      pickerName.label = item.locationCode;
      pickerName.value = item.locationCode + '(' + item.sendSpot + ')';
      pickerName.sendSpot = item.sendSpot;
      this.Loc.push(pickerName);
    });
  }
  empty() {
    this.list = [];
    this.wlCode = '';
    this.nowAmount = '';
    this.every = '';
    this.materialList = [];
    this.Loc = [];
  }
  async close(){
    if (this.form.documentNo == '') {
      this.customToast(this.$t('message.Commission_tips1') as any);
      return;
    }
    uni.showModal({
      content:this.$t('message.closing') as any,
      cancelText:this.$t('message.product_Cancel') as any,
      confirmText:this.$t('message.workArea_Confirm') as any,
      success:async (res) =>{
        if(res.confirm){
          await this.model.closeCode(this.form.documentNo)
          if(this.model.code == '1'){
            this.customToast(this.$t('message.Warehouse_Tip9') as any);
            this.empty()
            this.form.documentNo == ''
          }
        }else if(res.cancel){
          return
        }
      }
    })
  }
  //输入单号 查询数据
  async query() {
    this.list = [];
    this.wlCode = '';
    this.nowAmount = '';
    this.every = '';
    this.materialList = [];
    if (this.form.documentNo == '') {
      this.customToast(this.$t('message.Commission_tips1') as any);
      return;
    }
    this.materialList = [];
    let res = await this.model.queryOutsourcing(this.form.documentNo);
    this.material = res.data;
    this.material.forEach((item: any) => {
      let pickerName: any = {};
      pickerName.label = item.materialCode;
      pickerName.value = item.materialCode;
      this.materialList.push(pickerName);
    });
    this.every = this.material[0];
    this.materialIndex = 0
  }
  //选择物料后触发的回调事件  本次数量：receiptAmount  需求数量：requestAmount
  materialChoice(e: any) {
    this.nowAmount = ''
    this.material.forEach((item: any,index:any) => {
      if (item.materialCode == e.pickerName.value) {
        this.every = item;
        this.materialIndex = index
        return;
      }
    });
  }
  //选择库位后触发的回调事件
  LocationChoice(e: any) {
    this.wlCode = e.pickerName;
  }
  //点击添加
  Add() {
    if (!this.every) {
      this.customToast(this.$t('message.Commission_tips6') as any);
      return;
    }
    if (this.nowAmount == '' || this.wlCode == '') {
      this.customToast(this.$t('message.Commission_tips2') as any);
      return;
    }
    if (parseFloat(this.nowAmount) <= 0) {
      this.customToast(this.$t('message.Commission_tips3') as any);
      return;
    }
    let num: number = parseFloat(this.nowAmount) + parseFloat(this.every.outAmount);
    this.list.forEach((item: any) => {
      if(item.materialCode == this.every.materialCode){
        num += parseFloat(item.nowAmount);
      }
    });
    if (num > parseFloat(this.every.orderAmount)) {
      uni.showModal({
        title: this.$t('message.Pi_tip') as any,
        content: this.$t('message.demandQuantity') as any,
        cancelText: this.$t('message.Cancel') as any,
        confirmText: this.$t('message.workArea_Confirm') as any,
        success: (res) => {
          if (res.confirm) {
            let arr = {
              poNo: this.form.documentNo,
              materialCode: this.every.materialCode,
              loginName: this.session.loginName,
              factoryCode: this.session.factoryCode,
              wlCode: this.wlCode.label,
              nowAmount: this.nowAmount,
            };
            this.list.push(arr);
            this.material[this.materialIndex].outAmount += parseFloat(this.list[this.list.length - 1].nowAmount)
            this.nowAmount = ''
          } else if (res.cancel) {
            return;
          }
        },
      });
    } else {
      let arr = {
      poNo: this.form.documentNo,
      materialCode: this.every.materialCode,
      loginName: this.session.loginName,
      factoryCode: this.session.factoryCode,
      wlCode: this.wlCode.label,
      nowAmount: this.nowAmount,
      };
      this.list.push(arr);
      this.material[this.materialIndex].outAmount += parseFloat(this.list[this.list.length - 1].nowAmount)
      this.nowAmount = ''
    }
  }
  deleteItem(e: any) {
    uni.showModal({
      content:this.$t('message.product_Delete') as any,
      cancelText:this.$t('message.Cancel') as any,
      confirmText:this.$t('message.workArea_Confirm') as any,
      success:(res) =>{
        if(res.confirm){
          this.list.splice(e.contentIndex,1)
          let i:any
          this.material.forEach((item:any,index:any) =>{
            if(item.materialCode == e.lineData.materialCode){
              i = index
            }
          })
          this.material[i].outAmount -= parseFloat(e.lineData.nowAmount)
        }else if(res.cancel){
          return
        }
      }
    })
  }
  async onSubmit() {
    if (this.list == null || this.list.length == 0) {
      this.customToast(this.$t('message.Commission_tips5') as any);
    }
    await this.model.submitOutsourcing(this.list);
    this.empty();
  }
  async bill() {
    if (this.form.documentNo == '') {
      this.customToast(this.$t('message._tips6') as any);
      return;
    }
    let person = JSON.parse(localStorage.getItem('__GWMS_APP_STATE_DATA__') as any);
    let content = {
      loginName: person.session.user.loginName,
      poNo: this.form.documentNo,
      factoryCode: person.session.user.factoryCode,
    };
    await this.model.querydetaildlist(content);
    this.toPage(this.page.raw.commission.goOut.detail);
  }
}
</script>
<style lang="scss" scoped>
.page-raw-receipt {
  background: #f2f2f2 linear-gradient(0deg, #f2f2f2 0%, #4a78ea 51%, #1753ea 100%) no-repeat;
  background-size: 100% 600rpx;
  padding: 118rpx 30rpx 162rpx;
  min-height: 100%;
  .header {
    position: fixed;
    top: 36rpx;
    left: 0;
    right: 0;
    z-index: 99;
    display: flex;
    height: 88rpx;
    line-height: 88rpx;
    color: #fff;
    font-size: 34rpx;
    font-weight: 500;
    text-align: center;
    .title {
      flex: 3;
    }
    .left,
    .right {
      flex: 1;
    }
    .icon {
      display: flex;
      justify-content: center;
      align-items: center;
      width: 88rpx;
      height: 88rpx;
    }
  }
  .content {
    width: 100%;
    background: white;
    border-radius: 15rpx;
    padding: 10rpx;
    .single {
      width: 100%;
      height: 100rpx;
      display: flex;
      .single-left {
        width: 80%;
        height: 100%;
        display: flex;
        view {
          width: 130rpx;
          height: 100%;
          line-height: 100rpx;
        }
      }
      .single-right {
        button {
          margin-top: 15rpx;
          width: 150rpx;
          height: 70rpx;
        }
      }
    }
    .material {
      width: 100%;
      height: 100rpx;
      display: flex;
      .material-left {
        width: 100%;
        height: 100%;
        display: flex;
        view {
          width: 140rpx;
          line-height: 100rpx;
        }
        .search {
          padding-left: 9px;
        }
      }
    }
    .material {
      width: 100%;
      height: 100rpx;
      display: flex;
      .material-right {
        width: 100%;
        height: 100%;
        display: flex;
        .material-right-title {
          width: 140rpx;
          height: 100%;
          line-height: 100rpx;
        }
        .material-right-code {
          width: 80%;
          height: 100%;
          line-height: 100rpx;
          text-align: left;
          padding-left: 10px;
          // line-height: 100rpx;
        }
      }
    }
    .number {
      height: 100rpx;
      display: flex;
      .number-left {
        width: 50%;
        height: 100%;
        display: flex;
        .number-left-title {
          width: 120rpx;
          height: 100%;
          line-height: 100rpx;
        }
        .input {
          width: 200rpx;
          height: 70rpx;
          margin-top: 15rpx;
          margin-left: 15rpx;
        }
      }
      .number-right {
        width: 50%;
        height: 100%;
        display: flex;
        .number-right-title {
          width: 120rpx;
          height: 100%;
          line-height: 100rpx;
          text-align: center;
        }
        .input {
          width: 200rpx;
          height: 70rpx;
          margin-top: 15rpx;
          margin-left: 15rpx;
        }
      }
    }
    .library {
      width: 100%;
      height: 100rpx;
      display: flex;
      .library-left {
        width: 50%;
        height: 100%;
        display: flex;
        view {
          width: 70rpx;
          line-height: 100rpx;
        }
        .search {
          padding-left: 1px;
          text-align: center;
        }
      }
      .library-right {
        width: 50%;
        height: 100%;
        display: flex;
        .library-right-title {
          width: 120rpx;
          height: 100%;
          line-height: 100rpx;
          text-align: center;
        }
        .input {
          width: 200rpx;
          height: 70rpx;
          margin-top: 15rpx;
          margin-left: 15rpx;
        }
      }
    }
    .add {
      width: 100%;
      height: 100rpx;
      position: relative;
      button {
        position: absolute;
        top: 10rpx;
        right: 20rpx;
      }
    }
  }
  .bottom-bar {
    position: fixed;
    bottom: 0;
    left: 0;
    right: 0;
    z-index: 99;
    background: #ffffff;
    box-shadow: 0 1rpx 20rpx 0 rgba(128, 128, 128, 0.2);
    padding: 20rpx;
  }
}
</style>
